#ifndef __DEVICE_H
#define	__DEVICE_H

#include "stm32f4xx.h"
#include "sys/types.h"

#define TRUE	0xffffffff
#define FALSE	0x00000000

#define S_RX_SIZE	2048
#define S_TX_SIZE	2048

#define TCP_LISTEN_PORT	5000
#define UDP_LISTEN_PORT	5000

#define SOCK_DHCP		0	// UDP
#define SOCK_DNS		1	// UDP
#define SOCK_SMTP		2	// TCP

#define MAX_BUF_SIZE		1460
#define	MAX_SOCK_NUM		8	/**< Maxmium number of socket  */

typedef  unsigned char SOCKET;

#define IINCHIP_ISR_DISABLE()  __disable_fault_irq()
#define IINCHIP_ISR_ENABLE() __enable_fault_irq()

#ifndef NULL
#define NULL		((void *) 0)
#endif

//typedef enum { false, true } bool;

#ifndef _SIZE_T
#define _SIZE_T
typedef unsigned int size_t;
#endif

unsigned char S_Data_Buffer[2048];
unsigned char S_Data_Buffer1[2048];

#define TX_RX_MAX_BUF_SIZE	(2*1024)
extern uint8_t TX_BUF[TX_RX_MAX_BUF_SIZE];
extern uint8_t RX_BUF[TX_RX_MAX_BUF_SIZE];

typedef union _un_l2cval {
	u_long	lVal;
	u_char	cVal[4];
} un_l2cval;

typedef union _un_i2cval {
	u_int	iVal;
	u_char	cVal[2];
} un_i2cval;

typedef struct _CONFIG_TYPE_DEF
{
	uint16_t port;
	uint8_t destip[4];
} CHCONFIG_TYPE_DEF;

extern void System_Initialization(void);
#endif
