#ifndef __LED_H
#define	__LED_H

#include "stm32f4xx.h"

/* the macro definition to trigger the led on or off 
 * 1 - off
 - 0 - on
 */
#define ON  0
#define OFF 1

#if defined (STM32F429_439xx)

#define RCC_LED1				RCC_AHB1Periph_GPIOG
#define GPIO_LED1_PORT			GPIOG
#define GPIO_Pin_LED1			GPIO_Pin_13

#define RCC_LED2				RCC_AHB1Periph_GPIOG
#define GPIO_LED2_PORT			GPIOG
#define GPIO_Pin_LED2			GPIO_Pin_14

#define LED1(a)	if (a)	\
					GPIO_ResetBits(GPIO_LED1_PORT, GPIO_Pin_LED1);\
					else		\
					GPIO_SetBits(GPIO_LED1_PORT, GPIO_Pin_LED1)

#define LED2(a)	if (a)	\
					GPIO_ResetBits(GPIO_LED2_PORT, GPIO_Pin_LED2);\
					else		\
					GPIO_SetBits(GPIO_LED2_PORT, GPIO_Pin_LED2)

#elif defined (STM32F407VG)

#define RCC_LED1				RCC_AHB1Periph_GPIOD
#define GPIO_LED1_PORT			GPIOD
#define GPIO_Pin_LED1			GPIO_Pin_12

#define RCC_LED2				RCC_AHB1Periph_GPIOD
#define GPIO_LED2_PORT			GPIOD
#define GPIO_Pin_LED2			GPIO_Pin_13

#define RCC_LED3				RCC_AHB1Periph_GPIOD
#define GPIO_LED3_PORT			GPIOD
#define GPIO_Pin_LED3			GPIO_Pin_14

#define RCC_LED4				RCC_AHB1Periph_GPIOD
#define GPIO_LED4_PORT			GPIOD
#define GPIO_Pin_LED4			GPIO_Pin_15

#define LED1(a)	if (a)	\
					GPIO_ResetBits(GPIO_LED1_PORT,GPIO_Pin_LED1);\
					else		\
					GPIO_SetBits(GPIO_LED1_PORT,GPIO_Pin_LED1)

#define LED2(a)	if (a)	\
					GPIO_ResetBits(GPIO_LED2_PORT,GPIO_Pin_LED2);\
					else		\
					GPIO_SetBits(GPIO_LED2_PORT,GPIO_Pin_LED2)

#define LED3(a)	if (a)	\
					GPIO_ResetBits(GPIO_LED3_PORT,GPIO_Pin_LED3);\
					else		\
					GPIO_SetBits(GPIO_LED3_PORT,GPIO_Pin_LED3)

#define LED4(a)	if (a)	\
					GPIO_ResetBits(GPIO_LED4_PORT,GPIO_Pin_LED4);\
					else		\
					GPIO_SetBits(GPIO_LED4_PORT,GPIO_Pin_LED4)

#endif

void LED_GPIO_Config(void);

#endif /* __LED_H */
