#include "stm32f4xx.h"

#include "W5500.h"
#include "device.h"
#include "IO_define.h"
#include "led.h"
#include "dns.h"
#include "dhcp.h"
#include "socket.h"
#include "sockutil.h"
#include "hyperterminal.h"

#define MAX_URL_SIZE                            128

__IO uint32_t TimingDelay;

void W5500_Network_Configuration(void);
void SysTick_Init(void);
void Delay_ms(uint16_t nTime);
void W5500_Reset();
void network_init(void);
void DHCP_Configuration(void);
void SPI_Configuration(void);
void W5500_GPIO_Configuration(void);
void USART1_Init(void);
void USART1_GPIO_Configuration(void);
void NVIC_Configuration(void);
void System_Initialization(void);

//////////////////////////////////////////////////////////////////////////////////////////////
// Call back function for W5500 SPI - Theses used to parameter or reg_wizchip_xxx_cbfunc()  //
//////////////////////////////////////////////////////////////////////////////////////////////
void  wizchip_select(void);
void  wizchip_deselect(void);
void  wizchip_write(uint8_t wb);
uint8_t wizchip_read();

/*******************************************************
 * @ brief Call back for ip assing & ip update from DHCP
 *******************************************************/
void my_ip_assign(void);

/************************************
 * @ brief Call back for ip Conflict
 ************************************/
void my_ip_conflict(void);
