#include "stm32f4xx.h"
#include "http_client.h"
#include "main.h"

/* Network parameters---------------------------------------------------------*/
#define DNS_SOCK 1
#define HTTPC_SOCK 0

/* DNS parameters---------------------------------------------------------*/
#define DATA_BUF_SIZE   2048
uint8_t gDATABUF[DATA_BUF_SIZE];

#define	MAX_HTTP_BUF_SIZE	1024*4		// Maximum receive buffer size

NetInfo httpclient_NetInfo;

uint8_t str_start[6]= "<html>";
uint8_t str_end[7]= "</html>";
uint8_t done_dns = 0;
uint16_t wrt_idx = 0;
uint8_t flag = 1;

static char tx_buf[TX_RX_MAX_BUF_SIZE];
#define TX_BUF	tx_buf
uint8_t *data_buf = (uint8_t*) TX_BUF;	// Position of receive buffer



extern NetInfo  httpclient_NetInfo;
extern uint8_t done_dns;

void HttpClient(uint8_t *url)
{
	uint8_t  url_dn[MAX_URL_SIZE];			//domain name url
	uint8_t  url_path[MAX_URL_SIZE];		//local path in html server
	uint8_t Domain_DNS[4]  = {8, 8, 8, 8};
	char *split;				//string split pointer

	uint16_t done_http = 0;
	uint16_t start_idx = 0 ;
	uint16_t end_idx = 0;
	uint16_t tmp_start;
	uint16_t tmp_end;
	uint8_t BR [4]= "<BR>";
	uint8_t rBR [4]= "\r\n";
	uint8_t TITLE [7]= "<TITLE>";
	uint8_t bTITLE [8]= "</TITLE>";


	uint16_t tmp_idx;
	uint8_t no_pr = 0;

	/* Parse URL Path  */
	split = strchr((char const*)url, '/');
	strcpy((char*)url_path, split);
	printf("Domain path: %s \r\n", url_path);

	/* Parse URL Domain  */
	split = strtok((char*)url, "/");
	strcpy((char*)url_dn, split);
	printf("Domain name: %s \r\n", url_dn);


	/* Do DNS Client */
	memset(httpclient_NetInfo.ip, 0, sizeof(httpclient_NetInfo.ip));
	Delay_ms(10);
	/* DNS client initialization */
	DNS_init(SOCK_DNS, gDATABUF);

	done_dns = DNS_run(httpclient_NetInfo.ip, url_dn, Domain_DNS);
//	done_dns = dns_query(DNS_SOCK, url_dn, httpclient_NetInfo.ip);
	printf("\r\n HTTPs_IP= %d.%d.%d.%d", httpclient_NetInfo.ip[0], httpclient_NetInfo.ip[1], httpclient_NetInfo.ip[2], httpclient_NetInfo.ip[3]);

	while(done_dns) {

		/* Do HTTP Client */
		done_http = http_client(HTTPC_SOCK, httpclient_NetInfo.ip, url_path, url_dn, data_buf);

		if(done_http) { // on success, done_dns is not  '0'
			int i;

			#define Recieved_DATA
			#ifdef Recieved_DATA
			printf("\r\n<< Recieved Data -- START>> \r\n");

			for(i = 0; i < done_http; i++){
				printf("%c", (uint8_t)data_buf[i]);
			}
			printf("\r\n");
			printf("<< Recieved Data -- END>> \r\n");

			#endif
			/* parsed index */
			//All other HTML elements are nested between the opening <html> and </html> tags.
			start_idx = pased_idx((uint8_t *)str_start , sizeof(str_start), done_http );
			end_idx   = pased_idx((uint8_t *)str_end , sizeof(str_end), done_http );

			/* printf get <html> ...</html> */
			for(i = start_idx; i < (end_idx+7); i++){
			/* remove header */
				data_buf[i-start_idx] = data_buf[i];
			}
			printf("\r\n");


			/* replace <br> tag to \r\n */
			//The br tag is used for specifying a line break.
			do{
				tmp_idx = pased_idx((uint8_t*)BR, sizeof(BR), end_idx - start_idx) ;
				if(tmp_idx == 0 )
				break;

				memcpy((uint8_t *)data_buf+tmp_idx, (uint8_t*)rBR, sizeof(rBR)) ;
			}while(tmp_idx != end_idx - start_idx);

			#define Parsed_DATA
			#ifdef Parsed_DATA
			/* parsed DATA */
			printf("\r\n<< Parsed Data -- START >>");
			printf("\r\nTITLE : \r\n");
			/* parse <TITLE> and </TITLE> tags */
			tmp_start = pased_idx((uint8_t *)TITLE , sizeof(TITLE), (end_idx-start_idx)) + sizeof(TITLE);
			tmp_end   = pased_idx((uint8_t *)bTITLE , sizeof(bTITLE), (end_idx-start_idx));

			for(i = tmp_start; i < tmp_end; i++){
				printf("%c", (uint8_t)data_buf[i]); // printf title
			}

			printf("\r\n BODY : \r\n");
			/*DO NOT PRINT TAG COMMAND: between '<' with '>' */
			for(i = tmp_end; i < (end_idx - start_idx); i++){
				//Tag command - ex.)<PRE>
				//'<' is a start point of tag command.
				if((uint8_t)data_buf[i] == '<'){
				no_pr = 0;
			}
			//'>' is a end point of Tag command.
			//To avoid in row tags -> ex.) <PRE><H1>
			if((uint8_t)data_buf[i] == '>' && (uint8_t)data_buf[i + 1] != '<' ) {
				no_pr = 1;
				i++;
			}
			if(no_pr){
				Delay_ms(1);
				printf("%c", (uint8_t)data_buf[i]);
			}
		}
		printf("\r\n<< Parsed Data -- END >>\r\n");
		#endif
		/* Init. parameter */
		start_idx = 0;
		end_idx = 0;
		done_dns = 0;
		break;

		}
		//done_http
		//done_dns=0;
	}//while : done_dns == 1
}

uint16_t pased_idx(uint8_t *st_buf, uint16_t size, uint16_t data_len){
	uint16_t i, j, idx;
	idx = 0; i = 0;

	do{
		idx = 0;
		for(j = 0; j < size; j++){
			if(data_buf[i+j] == st_buf[j] ){
			  idx++;
			}
		}

		i++;

		if(i > data_len)
			break;

	}while( idx != (size) );

	idx  = i-1;
	return idx;
}

s16 http_client(uint8_t s, uint8_t *HTTPs_IP, uint8_t *url_path, uint8_t *url_dn, uint8_t * data_buf)
{
	unsigned long len;
	uint8_t http_req[1024];

	static uint16_t any_port = 5000;

	switch (getSn_SR(s))
	{
		case SOCK_ESTABLISHED:
		{
			if(flag){
				printf("< Connect OK >\r\n");

				sprintf((char*)http_req, "GET %s HTTP/1.1\r\nAccept: */*\r\nHost: %s\r\nUser-Agent: Mozilla/4.0 \r\n\r\n", url_path, url_dn);
				send(s, http_req, strlen((char *)http_req));

				flag = 0;
			}

			if ((len = getSn_RX_RSR(s)) > 0){
				if(wrt_idx>= TX_RX_MAX_BUF_SIZE)
				{
					printf("JumpAddress....?\n");
//					JumpAddress = *(volatile unsigned long*) (ApplicationAddress + 4); //reset app
//					Jump_To_Application = (pFunction) JumpAddress;
//					Jump_To_Application();
					while(1);
				}

				if (len > MAX_HTTP_BUF_SIZE) len = MAX_HTTP_BUF_SIZE;

				len = recv(s, (data_buf+wrt_idx) , len);
				wrt_idx += len;
			}

			if(strstr((char const*)data_buf, "</html>")){
				close(s);
				printf("< Disconnect >\r\n");
				return (wrt_idx);
			}

		}
		break;

		case SOCK_CLOSE_WAIT:
		{
			//Modified by Gang 2011-10-04
			if ((len = getSn_RX_RSR(s)) > 0)
			{
				if(wrt_idx>= TX_RX_MAX_BUF_SIZE)
				{
					printf("JumpAddress....?\n");
//					JumpAddress = *(volatile unsigned long*) (ApplicationAddress + 4); //reset app
//					Jump_To_Application = (pFunction) JumpAddress;
//					Jump_To_Application();
					while(1);
				}

					if (len > MAX_HTTP_BUF_SIZE) len = MAX_HTTP_BUF_SIZE;
						len = recv(s, (data_buf+wrt_idx) , len);
						wrt_idx += len;
				}

				if(strstr((char const*)data_buf, "</html>"))
				{
					close(s);
					printf("< Disconnect >\r\n");
					return (wrt_idx);
				}
		}
		break;

		case SOCK_CLOSED:
		{
			if (socket(s, Sn_MR_TCP, any_port, 0x00) == 1)
			{
				flag = 1;
				wrt_idx = 0;
				memset(data_buf, 0, sizeof(data_buf));
			}
		}
		break;
		/*
		{
			close(s);
			if ( (socket(s,Sn_MR_TCP,any_port++, 0) )!=1 ){
			printf("< Fail : socket > \r\n");
			}else{
			printf("\r\n<socket init OK! >\r\n");
			}
		}
		break;
		*/
		/*
		case SOCK_INIT:
		{
			if( (connect(s,(uint8_t*)HTTPs_IP, 80) )!= 1 ){
			printf("< Fail : connect >\r\n");
			}
			//Modified by Gang 2011-10-06
			else
			{
			flag=1;
			wrt_idx = 0;
			memset(data_buf,0,sizeof(data_buf));
			}
			if (TCPClientOpen(s, any_port++, (uint8_t*)httpclient_NetInfo.ip, 80) == 1)
			{
				flag = 1;
				wrt_idx = 0;
				memset(data_buf, 0, sizeof(data_buf));
			}
		}
		break;
		*/
	}

	return 0;
}
