#include "led.h"


void LED_GPIO_Config(void)
{		
	GPIO_InitTypeDef GPIO_InitStructure;

#if defined (STM32F429_439xx)

	RCC_AHB1PeriphClockCmd(RCC_LED1 | RCC_LED2, ENABLE);

	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_LED1 | GPIO_Pin_LED2;
  	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
  	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  	GPIO_Init(GPIO_LED1_PORT, &GPIO_InitStructure);

	GPIO_ResetBits(GPIO_LED1_PORT, GPIO_Pin_LED1);
	GPIO_ResetBits(GPIO_LED2_PORT, GPIO_Pin_LED2);

#elif defined (STM32F407VG)

	RCC_APB2PeriphClockCmd(RCC_LED1, ENABLE);

  	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_LED1;	
  	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;   
  	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz; 
  	GPIO_Init(GPIO_LED1_PORT, &GPIO_InitStructure);		  

	RCC_APB2PeriphClockCmd(RCC_LED2, ENABLE);
  	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_LED2;	
  	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;   
  	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz; 
  	GPIO_Init(GPIO_LED2_PORT, &GPIO_InitStructure);	

	RCC_APB2PeriphClockCmd(RCC_LED3, ENABLE);
  	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_LED3;	
  	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;   
  	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz; 
  	GPIO_Init(GPIO_LED3_PORT, &GPIO_InitStructure);	

	RCC_APB2PeriphClockCmd(RCC_LED4, ENABLE);
  	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_LED4;	
  	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;   
  	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz; 
  	GPIO_Init(GPIO_LED4_PORT, &GPIO_InitStructure);	

	GPIO_ResetBits(GPIO_LED1_PORT, GPIO_Pin_LED1);
	GPIO_ResetBits(GPIO_LED2_PORT, GPIO_Pin_LED2);
	GPIO_ResetBits(GPIO_LED3_PORT, GPIO_Pin_LED3);
	GPIO_ResetBits(GPIO_LED4_PORT, GPIO_Pin_LED4);

#endif
}
